题目链接:http://poj.org/problem?id=3126
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 32036 | Accepted: 17373 |
Description
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
Output
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0 求出素数在对每个位上的数进行bfs即可
#include<iostream>
#include<queue>
using namespace std;
int n,x,y,prime[],visit[],v[],ans;
void Prime()//欧拉筛
{
for(int i=;i<=;i++)
{
if(!visit[i])
{
prime[++prime[]]=i;
}
for(int j=;j<=prime[]&&i*prime[j]<=;j++)
{
visit[i*prime[j]]=;
if(i%prime[j]==)break;
}
}
}
struct node{
int a[],num,cnt;
};
int change(node p)
{
return p.a[]*+p.a[]*+p.a[]*+p.a[];
}
queue<node>q;
int bfs(node p)
{
while(!q.empty())
q.pop();
q.push(p);
p.num=change(p);
v[p.num]=;
while(!q.empty())
{
p=q.front(); if(p.num==y)return p.cnt;
q.pop();
for(int i=;i<;i++)
{
for(int j=;j<;j++)
{
if(i==&&j==)continue;
node w=p;
w.a[i]=j;
w.num=change(w);
if(!visit[w.num]&&!v[w.num])
{
w.cnt++;
q.push(w);
v[w.num]=;
}
}
}
}
return -;
}
int main()
{
Prime();
cin>>n;
while(n--)
{
cin>>x>>y;
for(int i=;i<=;i++)
v[i]=;
node p;
int num=x;
for(int i=;i>=;i--)
{
p.a[i]=num%;
num/=;
}
p.num=change(p);
p.cnt=;
ans=bfs(p);
if(ans!=-)cout<<ans<<endl;
else cout<<"Impossible"<<endl;
}
return ;
}